
CoCoALib - Feature #1176

interval arithmetic

05 Apr 2018 13:41 - John Abbott

Status: In Progress Start date: 05 Apr 2018

Priority: Normal Due date:  

Assignee: John Abbott % Done: 50%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-0.99880 Spent time: 2.80 hours

Description

Implement interval arithmetic (for intervals with rational end points).

Some software libraries already implement this; can we use one of them?

Related issues:

Related to CoCoALib - Feature #1173: Upper bound for value of poly in an inte... New 04 Apr 2018

Related to CoCoALib - Feature #1482: Extended rationals: PlusInfinity and Min... In Progress 31 Aug 2020

History

#1 - 05 Apr 2018 13:41 - John Abbott

- Related to Feature #1173: Upper bound for value of poly in an interval added

#2 - 05 Apr 2018 15:11 - John Abbott

There is an interval arithmetic sublibrary in the BOOST distribution.

The problem with depending on an external library is that it makes installing CoCoA harder (and could limit portability).

It should not be too hard to make our own impl using BigRat (so no problems with "rounding modes" etc.)

#3 - 12 Jun 2018 18:25 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99650 November 2019

- % Done changed from 0 to 50

A first prototype is in BigRatInterval

I have even written some doc!

#4 - 23 Sep 2019 12:56 - John Abbott

- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99700

#5 - 14 Nov 2019 19:32 - John Abbott

- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800

#6 - 31 Aug 2020 13:56 - John Abbott

- Related to Feature #1482: Extended rationals: PlusInfinity and MinusInfinity added

#7 - 31 Aug 2020 14:34 - John Abbott

There is a GNU package called MPRIA (multiple precision rational interval arithmetic).  It is GPL v3.

It seems not to have been updated since 2016, and has the version number 0.7.3 (suggesting it is far from final).
It does allow infinite intervals, but assumes that all end points are closed.

Should we take a copy?

#8 - 19 Mar 2021 12:04 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#9 - 10 Mar 2023 17:46 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880
